Apache log4cxx: Hierarchy Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Hierarchy Class Reference

Inherits LoggerRepository, and ObjectImpl.

List of all members.

## Detailed Description

This class is specialized in retrieving loggers by name and also maintaining the logger hierarchy.

The casual user does not have to deal with this class directly.

The structure of the logger hierarchy is maintained by the getLogger method. The hierarchy is such that children link to their parent but parents do not have any pointers to their children. Moreover, loggers can be instantiated in any order, in particular descendant before ancestor.

In case a descendant is created before a particular ancestor, then it creates a provision node for the ancestor and adds itself to the provision node. Other descendants of the same ancestor add themselves to the previously created provision node.

## Public Member Functions
| Hierarchy ()
| Create a new logger hierarchy.
| ~Hierarchy ()
void | addRef () const
void | releaseRef () const
void | addHierarchyEventListener (const spi::HierarchyEventListenerPtr &listener)
void | clear ()
| This call will clear all logger definitions from the internal hashtable.
void | emitNoAppenderWarning (const LoggerPtr &logger)
LoggerPtr | exists (const LogString &name)
| Check if the named logger exists in the hierarchy.
void | setThreshold (const LogString &levelStr)
| The string form of setThreshold.
void | setThreshold (const LevelPtr &l)
| Enable logging for logging requests with level `l` or higher.
void | fireAddAppenderEvent (const LoggerPtr &logger, const AppenderPtr &appender)
void | fireRemoveAppenderEvent (const LoggerPtr &logger, const AppenderPtr &appender)
const LevelPtr & | getThreshold () const
| Returns a Level representation of the `enable` state.
LoggerPtr | getLogger (const LogString &name)
| Return a new logger instance named as the first parameter using the default factory.
LoggerPtr | getLogger (const LogString &name, const spi::LoggerFactoryPtr &factory)
| Return a new logger instance named as the first parameter using `factory`.
LoggerList | getCurrentLoggers () const
| Returns all the currently defined loggers in this hierarchy as a LoggerList.
LoggerPtr | getRootLogger () const
| Get the root of this hierarchy.
bool | isDisabled (int level) const
| This method will return `true` if this repository is disabled for `level` object passed as parameter and `false` otherwise.
void | resetConfiguration ()
| Reset all values contained in this hierarchy instance to their default.
void | shutdown ()
| Shutting down a hierarchy will safely close and remove all appenders in all categories including the root logger.
virtual bool | isConfigured ()
virtual void | setConfigured (bool configured)

## Constructor & Destructor Documentation

Hierarchy | ( |  | ) |

| Create a new logger hierarchy.

~Hierarchy | ( |  | ) |

## Member Function Documentation

void addHierarchyEventListener | ( | const spi::HierarchyEventListenerPtr & | listener | ) |

void addRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

void clear | ( |  | ) |

| This call will clear all logger definitions from the internal hashtable. Invoking this method will irrevocably mess up the logger hierarchy. You should really know what you are doing before invoking this method.

void emitNoAppenderWarning | ( | const LoggerPtr & | logger | ) | `[virtual]`

| Implements LoggerRepository.

LoggerPtr exists | ( | const LogString & | name | ) | `[virtual]`

  | Check if the named logger exists in the hierarchy. If so return its reference, otherwise returns `null`. Parameters:
  | name | The name of the logger to search for.
Implements LoggerRepository.

void fireAddAppenderEvent | ( | const LoggerPtr & | logger,
|  | const AppenderPtr & | appender
| ) | `[virtual]`

| Implements LoggerRepository.

void fireRemoveAppenderEvent | ( | const LoggerPtr & | logger,
|  | const AppenderPtr & | appender
| ) |

LoggerList getCurrentLoggers | ( |  | ) | const`[virtual]`

| Returns all the currently defined loggers in this hierarchy as a LoggerList. The root logger is not included in the returned LoggerList. Implements LoggerRepository.

LoggerPtr getLogger | ( | const LogString & | name,
|  | const spi::LoggerFactoryPtr & | factory
| ) | `[virtual]`

  | Return a new logger instance named as the first parameter using `factory`. If a logger of that name already exists, then it will be returned. Otherwise, a new logger will be instantiated by the `factory` parameter and linked with its existing ancestors as well as children. Parameters:
  | name | The name of the logger to retrieve.
  | factory | The factory that will make the new logger instance.
Implements LoggerRepository.

LoggerPtr getLogger | ( | const LogString & | name | ) | `[virtual]`

  | Return a new logger instance named as the first parameter using the default factory. If a logger of that name already exists, then it will be returned. Otherwise, a new logger will be instantiated and then linked with its existing ancestors as well as children. Parameters:
  | name | The name of the logger to retrieve.
Implements LoggerRepository.

LoggerPtr getRootLogger | ( |  | ) | const`[virtual]`

| Get the root of this hierarchy. Implements LoggerRepository.

const LevelPtr& getThreshold | ( |  | ) | const`[virtual]`

| Returns a Level representation of the `enable` state. Implements LoggerRepository.

virtual bool isConfigured | ( |  | ) | `[virtual]`

| Implements LoggerRepository.

bool isDisabled | ( | int | level | ) | const`[virtual]`

| This method will return `true` if this repository is disabled for `level` object passed as parameter and `false` otherwise. See also the setThreshold method. Implements LoggerRepository.

void releaseRef | ( |  | ) | const`[virtual]`

| Reimplemented from ObjectImpl.

void resetConfiguration | ( |  | ) | `[virtual]`

| Reset all values contained in this hierarchy instance to their default. This removes all appenders from all categories, sets the level of all non-root categories to `null`, sets their additivity flag to `true` and sets the level of the root logger to DEBUG. Moreover, message disabling is set its default "off" value. Existing categories are not removed. They are just reset. This method should be used sparingly and with care as it will block all logging until it is completed. Implements LoggerRepository.

virtual void setConfigured | ( | bool | configured | ) | `[virtual]`

| Implements LoggerRepository.

void setThreshold | ( | const LevelPtr & | l | ) | `[virtual]`

  | Enable logging for logging requests with level `l` or higher. By default all levels are enabled. Parameters:
  | l | The minimum level for which logging requests are sent to their appenders.
Implements LoggerRepository.

void setThreshold | ( | const LogString & | levelStr | ) | `[virtual]`

| The string form of setThreshold. Implements LoggerRepository.

void shutdown | ( |  | ) | `[virtual]`

| Shutting down a hierarchy will safely close and remove all appenders in all categories including the root logger. Some appenders such as SocketAppender and AsyncAppender need to be closed before the application exists. Otherwise, pending logging events might be lost. The `shutdown` method is careful to close nested appenders before closing regular appenders. This is allows configurations where a regular appender is attached to a logger and again to a nested appender. Implements LoggerRepository.

The documentation for this class was generated from the following file:

- hierarchy.h